<?php
/*
Plugin Name: Sitemap 4 Google News 
Plugin URI: http://bueltge.de/google-news-quelle-mit-wordpress-werden/836/
Description: Generate a Google News Sitemap: <code>?feed=google_news_sitemap</code>
Version: 0.2
Author: Frank B&uuml;ltge
Author URI: http://bueltge.de/
*/


function google_news_sitemap() {
	global $wpdb;
	
	// draft, future
	$items = $wpdb->get_results("SELECT DISTINCT ID, post_date_gmt, post_title
															FROM $wpdb->posts, $wpdb->term_relationships, $wpdb->term_taxonomy
															WHERE $wpdb->term_relationships.object_id = $wpdb->posts.id
															AND post_status = 'publish'
															AND post_type = 'post'
															ORDER BY $wpdb->posts.post_date_gmt DESC
															LIMIT 0, 20");
	
	if ( !headers_sent() )
		header('Content-Type: text/xml; charset=' . get_option('blog_charset'), true);
	$more = 1;

echo '<?xml version="1.0" encoding="'.get_option('blog_charset').'"?>'; ?>

<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9"
	xmlns:news="http://www.google.com/schemas/sitemap-news/0.9">
<?php
if ( empty($items) ) {
	echo '<!-- No submissions found yet. //-->';
} else {
	foreach ($items as $item) {
		echo "\t" . '<url>' . "\n";
		echo "\t\t" . '<loc>';
		echo get_permalink($item->ID);
		echo '</loc>' . "\n";
		echo "\t\t" . '<news:news>' . "\n";
		echo "\t\t\t" . '<news:publication>' . "\n";
		echo "\t\t\t\t" . '<news:name>' . get_bloginfo('name') . '</news:name>' . "\n"; //eventuell haendisch pflegen
		echo "\t\t\t\t" . '<news:language>' . get_option('rss_language') . '</news:language>' . "\n";
		echo "\t\t\t" . '</news:publication>' . "\n";
		echo "\t\t\t" . '<news:genres>pressrelease, blog, UserGenerated</news:genres>' . "\n"; //eventuell haendisch pflegen
		echo "\t\t\t" . '<news:publication_date>';
		$thedate  = substr($item->post_date_gmt, 0, 10);
		$thetime  = substr($item->post_date_gmt, 11, 20);
		echo $thedate . 'T' . $thetime . 'Z';
		echo '</news:publication_date>' . "\n";
		echo "\t\t\t" . '<news:title>' . htmlspecialchars( $item->post_title ) . '</news:title>' . "\n";
		$tags     = wp_get_post_tags( $item->ID, array('fields' => 'all') );
		$tagcount = count($tags);
		if ($tagcount > 0) {
			echo "\t\t\t" . '<news:keywords>';
			for ($i = 0; $i < $tagcount; $i++) {
				echo $taglist  = str_replace( "'", '', str_replace( '"', '', urldecode($tags[$i]->name) ) );
				if ( $i != $tagcount-1 )
				 echo ', ';
			}
			echo '</news:keywords>' . "\n";
		}
		echo "\t\t" . '</news:news>' . "\n";
		echo "\t" . '</url>' . "\n";
	} ?>
</urlset>
<?php
}
}

function add_google_news_sitemap() {
	add_feed('google_news_sitemap', 'google_news_sitemap');
}
add_action('init','add_google_news_sitemap');
?>